<template>
  <GI18nCard :i18n="i18n" :card="card" v-bind="$attrs">
    <v-row dense>
      <GCol cols="12">
        <GTextField
          v-model="value._attr.refType"
          i18n="dcc.common.attributes.refType"
          attr-ref-type
        />
      </GCol>
      <GCol cols="12">
        <DccLocalizedTextBlock
          v-model="value.name"
          i18n="dcc.itemList.item.name"
          validate="required"
        />
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.model"
          i18n="dcc.itemList.item.model"
          validate="notEmptyStringType"
        />
      </GCol>
    </v-row>
    <EquipmentClass
      v-if="value.equipmentClass"
      ref="equipmentClass"
      v-model="value.equipmentClass"
      class="mb-4"
      i18n="dcc.common.equipmentClassType.title"
      optional
      level="second"
      wiki-entry="equipmentClass"
      @delete="deleteEquipmentClass"
    />
    <RichContent
      v-if="value.description"
      ref="description"
      v-model="value.description"
      class="mb-4"
      i18n="dcc.common.richContentType.description.title"
      optional
      not-in-dialog
      wiki-entry="richContent"
      @delete="deleteRichContent"
    />
    <SoftwareList
      v-if="value.installedSoftwares"
      ref="installedSoftwares"
      v-model="value.installedSoftwares"
      class="mb-4"
      optional
      i18n-base="dcc.itemList.item.installedSoftwares"
      level="second"
      @delete="deleteInstalledSoftwares"
    />
    <Contact
      v-if="value.manufacturer"
      ref="manufacturer"
      v-model="value.manufacturer"
      class="mb-4"
      not-strict
      i18n="dcc.itemList.item.manufacturer.title"
      level="third"
      wiki-entry="manufacturer"
      optional
      v-bind="$attrs"
      @delete="deleteManufacturer"
    />
    <IdentificationList
      v-model="value.identifications"
      level="second"
      wiki-entry="identifications"
    />
    <QuantityList
      v-if="value.itemQuantities"
      ref="itemQuantities"
      v-model="value.itemQuantities"
      class="mt-4"
      level="second"
      quantity-key="itemQuantity"
      primitive
      optional
      @delete="deleteItemQuantities()"
    />
  </GI18nCard>
</template>

<script>
import GI18nCard from "../../App/Common/GI18nCard";
import DccLocalizedTextBlock from "../../App/Form/XML/DccLocalizedTextBlock";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import Contact from "../Common/Contact";
import EquipmentClass from "../Common/EquipmentClass";
import IdentificationList from "../Common/IdentificationList";
import RichContent from "~/components/DCC/Common/RichContent";
import GCol from "~/components/App/Common/GCol";
import GTextField from "~/components/App/Form/gTextField";
import QuantityList from "~/components/DCC/Common/QuantityList.vue";
import SoftwareList from "~/components/DCC/Common/SoftwareList.vue";

export default {
  name: "Item",
  components: {
    SoftwareList,
    QuantityList,
    GTextField,
    GCol,
    RichContent,
    XmlTextField,
    IdentificationList,
    Contact,
    EquipmentClass,
    DccLocalizedTextBlock,
    GI18nCard,
  },
  props: {
    value: Object,
    i18n: {
      type: String,
      default: "dcc.itemList.item.title",
    },
    card: {
      type: Boolean,
      default: true,
    },
  },
  methods: {
    deleteEquipmentClass() {
      confirm(this.$t("dcc.common.equipmentClassType.confirmRemove")) &&
        this.$delete(this.value, "equipmentClass");
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
    deleteInstalledSoftwares() {
      confirm(this.$t("dcc.common.softwareListType.confirmRemove")) &&
        this.$delete(this.value, "installedSoftwares");
    },
    deleteItemQuantities() {
      confirm(this.$t("dcc.tables.quantityList.confirmRemove")) &&
        this.$delete(this.value, "itemQuantities");
    },
    deleteManufacturer() {
      confirm(this.$t("dcc.itemList.item.manufacturer.confirmRemove")) &&
        this.$delete(this.value, "manufacturer");
    },
  },
};
</script>
